<?php

/*
 *	 WebAlbum v0.2 
 *	~~~~~~~~~~~~~~~
 *
 *	Author: Mario Kicherer  < http://empanyc.net >
 *
 *	started: 08.10.2005
 *	
 *	v0.2 released: 08.04.2006 (This version is for testing only)
 *
 *	Dependencies:
 *
 *		- ImageMagick (http://www.imagemagick.org) for image processing
 *		- MPlayer (http://www.mplayerhq.hu) for extracting frames from movies
 *
 *	Thanks to:
 *
 *		- Everaldo.com Design Studio for the lock icon.
 *		- MarginalHacks.com for "album" and "DropShadow" which inspired me
 *
 */
 
 $alb_version = "0.2";
 $alb_date = "08|04|2006";
 $author = "<a style=\"font-family:Monospace,'Courier New', Courier;font-size:10pt;\" href=\"http://empanyc.net\">~anYc~</a>";

 $columns = 4;
 $width = 150;
 $height = 100;
 $root = "./";
 $froot = getcwd()."/";
 $tn_prefix = "tn_";
 $tn_dir = "_thumbs";
 $images_dir = "images/";
 $dirconfname = ".dirconf";
 $dirconf = "";
 $userlevel = 0;
 
 $known_img_types = array ("jpg");
 $known_mov_types = array ("avi","mpg","mov");
 $known_types = array_merge($known_img_types,$known_mov_types);

 $drops = $root."_DropShadow/";
 $sub = $_GET["sub"];
 $image = $_GET["image"];
 $pd = $_GET["pd"];
 $action = $_GET["action"];
 $winkel = $_GET["winkel"];
 
 $PHP_SELF = $_SERVER["SCRIPT_NAME"];
 
 function read_dirconf($datei)
 {
	$dirconf = "";
	settype($dirconf, "array");
	if (file_exists($datei)) {
		$ia = file($datei);
		for ($i=0;$i<count($ia);$i++) {
			parse_str($ia[$i],$result);
			$dirconf = array_merge($dirconf,$result);
		}
	}
	return $dirconf;
 }
 
 function get_opt_tree($dirs,$index) {
	global $froot;
	global $dirconfname;
	
	settype($tempa,"array");
	if (count($dirs) == $index) return $tempa;
	
	$gesdir = implode("/",array_slice($dirs,0,($index)));
	$tempa = read_dirconf($gesdir."/".$dirconfname);

	return array_merge($tempa, get_opt_tree($dirs,$index+1));;
 }
 
 function check_dir($dirs,$index) {
	if (count($dirs) == $index) return TRUE;
	global $froot;
	$gesdir = implode("/",array_slice($dirs,0,($index)));
	$dhandle = dir($froot.$gesdir);
	$ok = FALSE;
	while($entry=$dhandle->read()) { 
		if (/*($entry != ".")&&*/($entry != "..")&&(($dirs[$index]) == $entry)) $ok = TRUE;
	}
	$dhandle->close();
	if ($ok && check_dir($dirs,($index+1)) )
		return TRUE;
	else
		return FALSE;
 }
 

 function login() {
	global $sub;
	global $image;
	global $pd;
	print "<html><body><form name=formi action=\"".$PHP_SELF."\" method=get>Passwort: <input name=\"pd\" type=password><input type=\"hidden\" name=image value=\"".$image."\"><input type=\"hidden\" name=action value=\"trans\"><input type=\"hidden\" name=sub value=\"".$sub."\"><input type=submit value=OK></form></body></html>";
	die(); 
 }

 function prove_access($file,$key)
 {
	global $tn_dir;
	global $dirconfname;
	global $sub;
	global $image;
	global $pd;
	global $dirconf;
	global $userlevel;
	global $tn_dir;
	$ok = FALSE;
	$pd_set = FALSE;
	$ret = 0;
	
	$file = $tn_dir."/".implode("/",array_slice(explode("/",$file),1,-1))."/bla";//."<br>";
	
	$dirconf = get_opt_tree(explode("/",$file),1);
	
	if (trim($dirconf["spd"]) != "") {
		$pd_set = TRUE;
		if (md5(trim($dirconf["spd"])) == trim($key)) {
			$ok = TRUE;
			$userlevel = 1;
		}
	}
	
	if (trim($dirconf["mpd"]) != "") {
		if (md5(trim($dirconf["mpd"])) == trim($key)) {
			$userlevel = 2;
			$ok = TRUE;
		}
	}
	
	if (($pd_set) && (!$ok)) {
		if ((!isset($key)) || (trim($key) == "")) {
			$ret = -1;
		} else {
			$ret = 0;
		}
	}
	if ((!$pd_set) || ($ok)) $ret = 1;
	
	
	return $ret;
 }
 
######################################################################################################
### Main switch:

 switch ($action) {
	case "show" :
		$datei = $froot.$image;
		
		$result = prove_access(urldecode($image),$pd);
		if ($result != 1) {
			$datei= $drops."locked.jpg";
		}
		if (!file_exists($datei)) {
			$datei = $drops."bkgrnd.jpg";
		}
		if (!check_dir(explode("/",$image),0)) {
			$datei = $drops."bkgrnd.jpg";
		}
		
		switch (strtolower(substr($datei,-3)) ) {
			case "jpg" : header("Content-Type: image/jpeg"); break;
			case "avi" : header("Content-Type: video/x-msvideo"); break;
			case "mpg" : header("Content-Type: video/mpeg"); break;
			case "mov" : header("Content-Type: video/quicktime"); break;
		}
		header("Content-Disposition: inline; filename=\"".basename($datei)."\"");
		readfile($datei);
		break;
		
	case "pwd" :
			login();
		break;
		
	case "trans" :
			print "<html><head><meta http-equiv=\"refresh\" content=\"0;url=".$PHP_SELF."?sub=".$sub."&pd=".md5($pd)."\"></head></html>";
		break;
		
	case "rotate" :
			$tn = $tn_dir."/".dirname($image)."/".$tn_prefix.basename($image);
			if (file_exists($tn_dir."/".$image))
				$overlay = ($tn_dir."/".$image);
			else
				$overlay = ($images_dir.$image);
			system("jpegtran -copy all -rot ".$winkel." -trim -outfile \"".$tn.".tmp\" \"".$tn."\"");
			system("mv -f \"".$tn.".tmp\" \"".$tn."\"");
			system("jpegtran -copy all -rot ".$winkel." -trim -outfile \"".$tn_dir."/".$image.".tmp\" \"".$overlay."\"");
			system("mv -f \"".$tn_dir."/".$image.".tmp\" \"".$tn_dir."/".$image."\"");
			print "<html><head><meta http-equiv=\"refresh\" content=\"0;url=".$PHP_SELF."?sub=".$sub."&pd=".($pd)."\"></head></html>";
		break;	
	default:

 class item {
	var $tn;
	var $original;
	var $image;
	var $name;
	var $typ;
	var $date;
	var $except;
 }
 
 function check_overlay($image) {
	global $tverz;
	if (file_exists($tverz.$image->name)) 
		return $tverz.$image->name;
	else
		return $image->original;	
 }

 function make_dia($datei,$target) {
	global $drops;
	global $width;
	global $height;
	global $tverz;
	global $froot;
	global $images_dir;
	global $href_post;

	$text = "<table cellspacing=0 cellpadding=0 border=0>";

	if (!file_exists(trim(dirname($_SERVER["SCRIPT_FILENAME"])."/".$datei)) )
		$bildinfo = getimagesize(trim(dirname($_SERVER["SCRIPT_FILENAME"])."/".$drops."bkgrnd.jpg"));
	else
		$bildinfo = getimagesize(trim(dirname($_SERVER["SCRIPT_FILENAME"])."/".$datei));
	

	$text .= "<tr align=left valign=top><td width=8><img src=".$drops."Bord_LT.gif><img width=8 height=".($bildinfo[1]-17)." src=".$drops."Bord_L.gif></td><td><a href=\"".$target."\"><img border=0 src=\"".$PHP_SELF."?action=show&image=".$datei.$href_post."\"></a></td></tr>";
	$text .= "<tr align=left valign=top><td colspan=2><img src=".$drops."Bord_BL.gif><img height=9 width=".($bildinfo[0]-20)." src=".$drops."Bord_B.gif><img src=".$drops."Bord_BR.gif></td></tr>";
	
	$text .= "</table>"; 
	return $text;
 }
 
 function make_thumb_jpg($src,$dest) {
	system("convert -thumbnail 150x100 \"".$src."\" \"".$dest."\"");
 }
 
 function make_thumb_avi($src,$dest) {
 	global $froot;
//	system("ffmpeg -i \"".$src."\" -ss 0 -vframes 1 -t 0.001 -y \"".$dest."%d.jpg\"");
	exec("mplayer -frames 1 -vo jpeg outdir=\"".$froot."\"  \"".$src."\"");
//	system("convert -thumbnail 150x100 \"".$dest."1.jpg\"  \"".$dest.".jpg\"");
	system("convert -thumbnail 150x100 \"".$froot."00000001.jpg\"  \"".$dest."\"");
	system("rm 00000001.jpg");
	
 }

 if (isset($sub)) {
	if ( substr($sub,-1) == "/") $sub2 = substr($sub,0,count($sub)-2);
	$subarray = explode("/", $images_dir.$sub2);
	if (!check_dir($subarray,0)) die("Invalid Sub");
 }

 $verz = $images_dir.$sub;
 if (!is_dir($tn_dir)) {mkdir($tn_dir);chmod($tn_dir,0774);}
 if (!is_dir($images_dir)) {mkdir($images_dir);chmod($images_dir,0774);}
 $tverz = $tn_dir."/".$sub;
 $dhandle = dir($froot.$verz);
 $href_post = "&pd=".$pd;
 
 $result = prove_access(urldecode($verz."index"),$pd);
 
 switch ($result) {
 	case 0 : die("Access denied."); break;
 	case -1 : login(); break;
 }
		

 $i = -1;
 $j = -1;
 
######################################################################################################
### Collect directories and images:
 
 while($entry=$dhandle->read()) { 
	$nentry = $froot.$verz.$entry;

	if (is_dir($nentry) && ($entry != ".") && ($entry != "..") && ($entry[0] != "_")) {
		$i++;
		$dirs[$i] = $entry;
		
		$result = prove_access(urldecode($verz.$entry."/index"),$pd);
		if ($result != 1) {
			$dirs_locked[$i] = 1;
		} else {
			$dirs_locked[$i] = 0;
		}
		
		$shandle = dir($nentry);
		$k = -1;
		$tdirimages[$i][0] = "";
		$dir_itemc[$i] = -2;
		if (!file_exists($tverz.$entry)) {mkdir($tverz.$entry); chmod($tverz.$entry,0774);}
		while($sentry=$shandle->read()) { 
			$dir_itemc[$i]++;
			if (is_file($nentry."/".$sentry) && (in_array(strtolower(substr($sentry,-3)), $known_types) ) 
					) {
				$k++;
				$dirimages[$i][$k] = $entry."/".$sentry;
				
				if (in_array(strtolower(substr($sentry,-3)), $known_mov_types)) {
					$tdirimages[$i][$k] = $entry."/".$tn_prefix.$sentry.".jpg";
				} 
				if (in_array(strtolower(substr($sentry,-3)), $known_img_types)) {
					$tdirimages[$i][$k] = $entry."/".$tn_prefix.$sentry;
				}
				
				if (!file_exists($tverz.$tdirimages[$i][$k])) {
					if (in_array(strtolower(substr($sentry,-3)),$known_img_types) ) {
						make_thumb_jpg($froot.$verz.$dirimages[$i][$k], $froot.$tverz.$tdirimages[$i][$k]);
					}
					if ( (in_array(strtolower(substr($sentry,-3)), $known_mov_types))
						 && (!file_exists($tverz.$tdirimages[$i][$k].".jpg") )) {
						make_thumb_avi($froot.$verz.$dirimages[$i][$k], $froot.$tverz.$tdirimages[$i][$k]);
					}
				}
			}
		}
		if ((file_exists($tverz.$entry."/tn_cover.jpg"))) $tdirimages[$i][0] = $entry."/tn_cover.jpg";
		$subdirconf = read_dirconf($tverz.$entry."/".$dirconfname);
		if (trim($subdirconf["cover"]) != "") $tdirimages[$i][0] = $subdirconf["cover"];
		$shandle->close;
	}

	if ( is_file($nentry)  && (in_array(strtolower(substr($nentry,-3)), $known_types) )  ) {
		$j++;
		$files[$j] = new item();
		$files[$j]->original = $verz.$entry;
		$files[$j]->name = $entry;
		$files[$j]->image = check_overlay($files[$j]);
		if (strpos($dirconf["except"], trim($entry)) <= -1 )
			$files[$j]->except = false;
		else
			$files[$j]->except = true;

		settype($temp_datum_array, "array");
		if (in_array(strtolower(substr($nentry,-3)),$known_mov_types)) {
			$files[$j]->tn = $tverz.$tn_prefix.$entry.".jpg";
			$files[$j]->typ = "mov";
			$files[$j]->date = gmdate("Y:m:d H:i:s",filectime($nentry));
			$temp_datum_array[$j] = $files[$j]->date;
		}
		if (in_array(strtolower(substr($nentry,-3)),$known_img_types)) {
			$files[$j]->tn = $tverz.$tn_prefix.$entry;
			$files[$j]->typ = "img";
			@$exif = exif_read_data($files[$j]->original);
			$files[$j]->date = $exif["DateTimeOriginal"];
			$temp_datum_array[$j] = $files[$j]->date;
		}
		
		if (!file_exists($froot.$files[$j]->tn)) {
					if ($files[$j]->typ == "img") {
						make_thumb_jpg($froot.$files[$j]->image, $froot.$files[$j]->tn);
					}
					if (($files[$j]->typ == "mov") && (!file_exists($files[$j]->tn) )) {
						make_thumb_avi($froot.$files[$j]->image, $froot.$files[$j]->tn);
					}
		}
	}
 }
 $dhandle->close();
 if (count($dirs) > 0 ) array_multisort($dirs,SORT_DESC, $tdirimages, $dir_itemc, $dirs_locked);
 if (count($files) > 0 ) array_multisort($temp_datum_array,SORT_ASC, $files);

######################################################################################################
### Content:

 $style= "color:#0099FF;font-weight:normal;font-size:17px;font-family:'Times New Roman','Georgia','Times';}";
 print "<html><head>
<title></title>
<style> 
 a : {text-decoration:none;".$style."
 a:link {text-decoration:none;".$style."
 a:visited {text-decoration:none;".$style."
 a:hover {text-decoration:underline;".$style."
 a:active {text-decoration:none;".$style."
 a:focus {text-decoration:none;".$style."
</style>
</head><body>";

 print "<table width=100% border=0><tr>";

 print "<tr height=24><td colspan=".($columns-1)." style=\"font-size:14pt;font-weight:bold;font-family:'Times New Roman','Georgia','Times'\">";
 $subarray = explode("/",$sub);
 if (isset($sub)) print "<a href=\"".$_SERVER["SCRIPT_NAME"]."?".$href_post."\">";
 print "Root";
 if (isset($sub)) print "</a>";
 for ($i=0;$i<count($subarray)-2;$i++) {
	print " / <a href=\"".$_SERVER["SCRIPT_NAME"]."?sub=".implode("/",array_slice($subarray,0,$i+1))."/&".$href_post."\">".$subarray[$i]."</a>";
	if ($i == count($subarray)-3) $temp = implode("/",array_slice($subarray,0,$i+1));
 }
 print " / ".$subarray[count($subarray)-2];
 print "</td><td align=right>";
 if (isset($sub)) print "<a href=\"".$_SERVER["SCRIPT_NAME"]."?pd=".$pd."&sub=".$temp."/\">zurck</a>&nbsp;:: ";
 print "<a href=\"".$PHP_SELF."?action=pwd&sub=".$sub."\">Login</a>&nbsp;&nbsp;&nbsp;";
 print "</td></tr>";
 print "<tr><td colspan=".($columns)."><br><br></td></tr>";

 $PHP_SELF=basename($_SERVER["PHP_SELF"]);

 print "<tr>";
 $k= -1;
 
/////////// print directories
 
 for ($i=0;$i<count($dirs);$i++) {
	$k++;
	
	if ($dirs_locked[$i] == 1) 
		$locked = "<img height=24 width=32 src=".$drops."locked_small.jpg>";
	else
		$locked = "";
	
	if ($k%$columns == 0) print "</tr><tr>";
	print "<td align=center width=".(100/$columns)."% >";
	print make_dia($tverz.$tdirimages[$i][0],$PHP_SELF."?action=browse&sub=".$sub.$dirs[$i]."/&".$href_post);
	print "<span style=\"font-size:3pt;\"><br></span><a style=\"font-weight:bold;\" href=\"".$PHP_SELF."?action=browse&sub=".$sub.$dirs[$i]."/&".$href_post."\">".$dirs[$i]."</a>".$locked."<br>"/*<span style=\"font-size:8pt;color:#888888;\">".$dir_itemc[$i]." Dateien "</span><br>"*/;
	print "<br><br></td>";
 }
 
////////// print thumbnails
 
 for ($i=0;$i<count($files);$i++) {
	if (!$files[$i]->except) {
		$k++;
	
		$datum = $files[$i]->date;
	
		if ($k%$columns == 0) print "</tr><tr>";
		print "<td align=center width=".(100/$columns)."%>";
		print make_dia($files[$i]->tn,$PHP_SELF."?action=show&image=".$files[$i]->image.$href_post);
		print "<a href=\"".$PHP_SELF."?action=show&image=".$files[$i]->image."\">".$files[$i]->name."</a><br><span style=\"font-size:8pt;color:#888888;\">".bcdiv(filesize($files[$i]->original),1024,0)." KB (".$datum.")</span><br>";
	
		if (($userlevel == 2) && ($files[$i]->typ == 'img')) {
			$winka = "<a style=\"font-size:8pt;color:#8888D8;\" href=\"".$PHP_SELF."?action=rotate&image=".$sub.$files[$i]->name."&winkel=";
			print $winka."270&sub=".$sub.$href_post."\">-90</a>";		
			print " <span style=\"font-size:8pt;color:#8888D8;\">Rotate</span> ";
			$winka = "<a style=\"font-size:8pt;color:#8888D8;\" href=\"".$PHP_SELF."?action=rotate&image=".$sub.$files[$i]->name."&winkel=";
			print $winka."90&sub=".$sub.$href_post."\">+90</a>";		
		}
		print "<br><br></td>";	
	}
 }

 print "</tr>";
 print "<tr><td>";
 if (($userlevel == 2) && (trim($dirconf["except"]) != "") ) {
	print "<span style=\"font-size:10pt;color:#888888;\">Excepted images: ";
	for ($i=0;$i<count($files);$i++) { 
		if ($files[$i]->except) 
			print "<a style=\"font-size:10pt;\" href=\"".$PHP_SELF."?action=show&image=".$files[$i]->image.$href_post."\">".$files[$i]->name."</a>&nbsp;";
	}
 }
 print "</span></td><td align=right colspan=".($columns-1)." style=\"font-family:Monospace,'Courier New', Courier;font-size:10pt;\">WebAlbum v".$alb_version." - ".$alb_date." ".$author." </td></tr>";
 print "</table>";

 print "</body></html>";
 break;
 }
?>
